routes/web.php
<?php

use App\Http\Controllers\Auth\AuthController;
use App\Http\Controllers\Dashboard\DashboardController;
use App\Http\Controllers\lab\LabController;
use App\Http\Controllers\lab\PasienController as LabPasienController;
use App\Http\Controllers\lab\ResultLabController;
use App\Models\Pasien;
use App\Http\Controllers\rawatjalan\KunjunganController;
use App\Http\Controllers\Pasien\PasienController;
use App\Http\Controllers\RekamMedis\EntryKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatKunjunganController;
use App\Http\Controllers\RekamMedis\RiwayatMedisController;
use App\Http\Controllers\Pembayaran\PembayaranController;
use App\Http\Controllers\Pharmacy\PharmacyController;
use Illuminate\Support\Facades\Route;

Route::controller(AuthController::class)->group(function () {
    Route::get('/', 'index')->name('login');
    Route::post('/', 'login')->name('loginPost');
    Route::get('/logout', 'logout')->name('logout');
});

Route::middleware('authenticated')->group(function () {
    // Dashboard Route
    Route::middleware('auth-roles:staff,dokter,admin,teknisi,perawat')->group(function () {
        // Pharmacy Route
        Route::prefix('pharmacy')->name('pharmacy.')->group(function () {
            Route::controller(PharmacyController::class)->group(function () {
                // prescription area
                Route::get('/receipt/{id}', 'getPrescriptionView')->name('prescriptionView');
                Route::get('/receipt/{visitId}/detail/{id}', 'getPrescriptionDetailView')->name('prescriptionDetail');
                Route::post('/receipt/detail', 'createDrugInPrescription')->name('createDrugInPrescription');
                Route::post('/receipt//detail/destroy/{id}', 'destroyDrugInPrescription')->name('destroyDrugInPrescription');
                Route::post('/receipt/detail/update/', 'updateDrugInPrescription')->name('updateDrugInPrescription');
                Route::get('/receipt/checkout/{id}/{visitId}', 'checkoutPrescription')->name('checkoutPrescription');

                // drug area
                Route::get('/medicine', 'listMedicine')->name('listMedicine');
                Route::get('/medicine/{id}', 'detailMedicine')->name('detailMedicine');
                Route::post('/medicine/{id}/destroy', 'destroyDrug')->name('destroyMedicine');
                Route::post('/medicine', 'createDrug')->name('createMedicine');
                Route::post('/medicine/{id}', 'updateDrug')->name('updateMedicine');
                Route::post('/medicine/{id}/update', 'updateDrugStock')->name('updateMedicineStock');
                Route::get('/medicine/export', 'downloadDrugExcel')->name('downloadDrugExcel');
            });
        });


        // Dashboard
        Route::controller(DashboardController::class)->group(function () {
            Route::get('/dashboard', 'index')->name('dashboard');
        });

        // START RJ
        // get data all detail kunjungan RJ
        Route::get('/rawat-jalan/detail-kunjungan', [KunjunganController::class, 'index'])->name('rawatjalan.index');

        // get data pemeriksaan lab and apotek
        Route::get('/rawat-jalan/set-data-pemeriksaan', [KunjunganController::class, 'pemeriksaan'])->name('rawatjalan.pemeriksaan');

        // get url add diagnosa
        Route::get('/rawat-jalan/{detailkunjungan}/add-diagnosa', [KunjunganController::class, 'adddiagnosa'])->name('rawatjalan.adddiagnosa');

        // patch data diagnosa
        Route::patch('/rawat-jalan/{detailkunjungan}/add-diagnosa/success-added', [KunjunganController::class, 'adddiagnosaAdded'])->name('rawatjalan.adddiagnosaAdded');

        // get url add data's (dokter,room,poli)
        Route::get('/rawat-jalan/detail-kunjungan/{detailkunjungan}/add-data-result', [KunjunganController::class, 'show'])->name('rawatjalan.show');

        // patch data results
        Route::patch('/rawat-jalan/detail-kunjungan/{detailkunjungan}/added-data-result', [KunjunganController::class, 'store'])->name('rawatjalan.store');

        // get sorting belum pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/belum-pemeriksaan', [KunjunganController::class, 'sortingBelumPemeriksaan'])->name('rawatjalan.belumPemeriksaan');

        // get sorting sudah pemeriksaan
        Route::get('/rawat-jalan/detail-kunjungan/sudah-pemeriksaan', [KunjunganController::class, 'sortingSudahPemeriksaan'])->name('rawatjalan.sudahPemeriksaan');

        // get edit data page n fetch data 
        Route::get('/rawat-jalan/update-kunjungan/{detailkunjungan}/edit-datas', [KunjunganController::class, 'edit'])->name('rawatjalan.edit');

        // Update data
        Route::patch('/rawat-jalan/update-kunjungan/{detailkunjungan}/update-datas', [KunjunganController::class, 'update'])->name('rawatjalan.update');

        // delete data kunjungan 
        Route::delete('rawat-jalan/deleted/{detailkunjungan}/datas', [KunjunganController::class, 'destroy'])->name('rawatjalan.destroy');
    });

    Route::controller(PasienController::class)
        ->prefix('pasien')
        ->name('pasien.')
        ->group(function () {
            Route::get('/', 'index')->name('index');
            Route::get('/create', 'create')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/edit/{id}', 'edit')->name('edit');
            Route::post('/update/{id}', 'update')->name('update');
            Route::delete('/delete/{id}', 'delete')->name('delete');
        });

    // example when group route with the role
    Route::middleware('auth-roles:admin')->group(function () {
        Route::get('/onlyadmin', function () {
            return 'Only Admin';
        });
        Route::get('/lab', [LabController::class, 'index'])->name('lab.index');
        Route::get('/lab/create', [LabController::class, 'create'])->name('lab.create');
        Route::get('/lab/edit/{lab}', [LabController::class, 'edit'])->name('lab.edit');
        Route::put('/lab/edit/{lab}', [LabController::class, 'update'])->name('lab.update');
        Route::delete('/lab/{lab}', [LabController::class, 'destroy'])->name('lab.destroy');
        Route::post('/lab', [LabController::class, 'store'])->name('lab.store');

        Route::controller(ResultLabController::class)->group(function () {
            Route::get('/result-lab', 'index')->name('resultLab.index');
            Route::get('/result-lab/create', 'create')->name('resultLab.create');
            Route::post('/result-lab', 'store')->name('resultLab.store');
            Route::get('/result-lab/{resultLab}', 'show')->name('resultLab.show');
            Route::delete('/result-lab/{resultLab}', 'destroy')->name('resultLab.destroy');
            Route::get('/result-lab/edit/{resultLab}', 'edit')->name('resultLab.edit');
            Route::put('/result-lab/{resultLab}', 'update')->name('resultLab.update');
            Route::get('/result-lab/download/{resultLab}', 'download')->name('resultLab.download');
        });
    });

    Route::prefix('/pembayaran')->name('pembayaran')->group(function () {
        Route::get('/', [PembayaranController::class, 'index']);

        Route::prefix('/transaksi')->name('-transaksi')->group(function () {
            Route::get('/', [PembayaranController::class, 'transaksi']);
            Route::get('/{page?}', [PembayaranController::class, 'transaksi'])->name('-pagination');
            Route::post('/confirmation/{id?}', [PembayaranController::class, 'update'])->name('-update');
        });

        Route::prefix('/riwayat')->name('-riwayat')->group(function () {
            Route::get('/', [PembayaranController::class, 'riwayat'])->name('-transaksi');
            Route::get('/cetak/{id?}', [PembayaranController::class, 'cetak'])->name('-cetak');
        });
    });
});

Route::view('/example', 'example.example')->name('example');
Route::prefix('rekam-medis')->group(function () {
    Route::controller(EntryKunjunganController::class)
        ->prefix('/entry-kunjungan')
        ->name('entry-kunjungan.')
        ->group(function () {
            Route::get('/', 'showEntryKunjungan')->name('index');
            Route::get('/create', 'createEntryKunjungan')->name('create');
            Route::post('/store', 'store')->name('store');
            Route::get('/{id}', 'details')->name('detail');
        });
    Route::controller(RiwayatKunjunganController::class)
        ->prefix('/riwayat-kunjungan')
        ->name('riwayat-kunjungan.')
        ->group(function () {
            Route::get('/', 'showRiwayatKunjungan')->name('index');
            Route::get('/detail', 'showDetailRiwayatKunjungan')->name('detail');
        });
    Route::controller(RiwayatMedisController::class)
        ->prefix('/riwayat-medis')
        ->name('riwayat-medis.')
        ->group(function () {
            Route::get('/', 'showRiwayatMedis')->name('index');
        });
});

app/Http/Controllers/RekamMedis/EntryKunjunganController.php
<?php

namespace App\Http\Controllers\RekamMedis;

use App\Http\Controllers\Controller;
use App\Models\Kunjungan;
use App\Models\Pasien;
use Illuminate\Http\Request;
use App\Models\DetailKunjungan;
use App\Models\Invoice;

class EntryKunjunganController extends Controller
{
    private Kunjungan $kunjungan;
    private Pasien $pasien;
    private DetailKunjungan $detailKunjungan;
    private Invoice $invoices;

    public function __construct(Kunjungan $kunjungan, Pasien $pasien, DetailKunjungan $detailKunjungan, Invoice $invoices)
    {
        $this->kunjungan = $kunjungan;
        $this->pasien = $pasien;
        $this->detailKunjungan = $detailKunjungan;
        $this->invoices = $invoices;
    }
    public function showEntryKunjungan()
    {
        return view('rekam-medis.entry-kunjungan.index', [
            'kunjungan' => $this->kunjungan->all()
        ]);
    }
    public function createEntryKunjungan()
    {
        return view('rekam-medis.entry-kunjungan.create', [
            'pasien' => $this->pasien->all()
        ]);
    }
    public function store(Request $request)
    {
        try {
            $validated = $request->validate([
                'pasien_id' => 'required|exists:pasiens,id',
                'tanggal_kunjungan' => 'required|date',
                'keluhan' => 'required|string',
            ]);


            $kunjungan = $this->kunjungan->create($validated);
            $res = $this->detailKunjungan->create([
                'kunjungan_id' => $kunjungan->id,
                'pembayaran' => 30000,
            ]);

            // dd($this->detailKunjungan);
            $this->invoices->create([
                'id_detail_kunjungan' => $res->id,
            ]);

            return response()->json([
                'message' => 'Berhasil menambahkan data kunjungan'
            ], 200);
        } catch (\Exception $error) {
            return response()->json([
                'message' => $error->getMessage()
            ], 500);
        }
    }

    public function details($id)
    {
        if (!$this->kunjungan->find($id)) {
            return response()->json([
                'message' => 'Data kunjungan tidak ditemukan'
            ], 404);
        }
        return view('rekam-medis.entry-kunjungan.details', [
            'pasien' => $this->kunjungan->find($id),
            'kunjungan' => $this->detailKunjungan->where('kunjungan_id', $id)->get(),
            'jumlah_kunjungan' => $this->detailKunjungan->where('kunjungan_id', $id)->count()
        ]);
    }
}

app/Http/Controllers/RekamMedis/RiwayatKunjunganController.php
<?php

namespace App\Http\Controllers\RekamMedis;

use App\Http\Controllers\Controller;

class RiwayatKunjunganController extends Controller
{
    public function showRiwayatKunjungan()
    {
        return view('rekam-medis.riwayat-kunjungan.index');
    }
    public function showDetailRiwayatKunjungan()
    {
        return view('rekam-medis.riwayat-kunjungan.detail');
    }
}

app/Http/Controllers/RekamMedis/RiwayatMedisController.php
<?php

namespace App\Http\Controllers\RekamMedis;

use App\Http\Controllers\Controller;

class RiwayatMedisController extends Controller
{
    public function showRiwayatMedis()
    {
        return view('rekam-medis.riwayat-medis.index');
    }
}

resources/views/rekam-medis/entry-kunjungan/create.blade.php
@extends('templates.master')
@section('title', 'Tambah Kunjungan')
@section('page-name', 'Tambah Kunjungan')
@push('styles')
@endpush
@section('content')
    <div class="card">
        <div class="card-header">
            <h4 class="card-title"></h4>
        </div>
        <div class="card-body">
            <form action="{{ route('entry-kunjungan.create') }}" id="form">
                <div class="form-grpup">
                    <label for="pasien">Daftar Pasien</label>
                    <select name="pasien_id" id="pasien" class="form-control">
                        <option value="" selected disabled>-- Nama Pasien --</option>
                        @foreach ($pasien as $item)
                            <option value="{{ $item->id }}">{{ $item->nama }}</option>
                        @endforeach
                    </select>
                </div>
                <div class="form-group">
                    <label for="tanggal_kunjungan">Tanggal Kunjungan</label>
                    <input type="date" name="tanggal_kunjungan" id="tanggal_kunjungan" class="form-control">
                </div>
                <div class="form-group">
                    <label for="keluhan">Keluhan</label>
                    <textarea name="keluhan" id="" cols="30" rows="5" class="form-control"></textarea>
                </div>

                <button type="submit" class="btn btn-primary">Simpan</button>
            </form>
        </div>
    </div>
@endsection
@push('scripts')
    <script src="https://code.jquery.com/jquery-3.7.1.min.js" integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script>
        $('#form').on('submit', function(e) {
            e.preventDefault();
            $.ajax({
                headers: {
                    'X-CSRF-TOKEN': "{{ csrf_token() }}"
                },
                method: "POST",
                data: $(this).serialize(),
                url: "{{ route('entry-kunjungan.store') }}",
                success: function(response) {
                    swal({
                        title: "Success",
                        text: response.message,
                        icon: "success",
                    });
                    $('#form').trigger('reset');
                },
                error: function(xhr, status, error) {
                    swal({
                        title: "Error",
                        text: xhr.responseJSON.message,
                        icon: "error",
                    });
                }
            })
        })
    </script>
@endpush

resources/views/rekam-medis/entry-kunjungan/details.blade.php
@extends('templates.master')
@section('title', 'Rekam Medis')
@section('page-name', 'Detail Riwayat Kunjungan')
@push('styles')
    <link rel="stylesheet" href={{ asset('assets/extensions/simple-datatables/style.css') }}>
    <link rel="stylesheet" href={{ asset('assets/scss/pages/simple-datatables.scss') }}>
    <link rel="stylesheet" href="{{ asset('assets/css/custome/style.css') }}">
@endpush
@section('content')
    <div class="card">
        <div class="card-content">
            <div class="card-body">
                <h5 class="card-title">Biodata Pasien</h5>
                <p class="card-text">
                    Riwayat kunjungan dan informasi rekam medis pasien
                </p>
            </div>
        </div>
        <div>
            <div class="container list">
                <ul class="list-group list-group-flush">
                    <li class="list-group-item"><span class="label">Nama </span>: {{ $pasien->pasien->nama }}</li>
                    <li class="list-group-item"><span class="label">Alamat </span>: {{ $pasien->pasien->alamat }}</li>
                    <li class="list-group-item"><span class="label">Tanggal kunjungan </span>: {{ $pasien->tanggal_kunjungan }}</li>
                    <li class="list-group-item"><span class="label">Tanggal Lahir </span>: {{ date('d F Y', strtotime($pasien->tanggal_lahir)) }}
                    <li class="list-group-item"><span class="label">No. KTP </span>: {{ $pasien->pasien->no_ktp }}</li>
                    <li class="list-group-item"><span class="label">No. BPJS </span>: {{ $pasien->pasien->no_bpjs }}</li>
                    <li class="list-group-item"><span class="label">Jumlah Kunjungan </span>: {{ $jumlah_kunjungan }}</li>
                </ul>
            </div>
        </div>
    </div>
    <div class="page-heading">
        <section class="section">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title">
                        Data Riwayat Medis
                    </h5>
                </div>
                <div class="card-body">
                    <table class="table table-striped" id="table1">
                        <thead>
                        <tr>
                            <th>Tanggal Kunjungan</th>
                            <th>Tujuan Kunjungan</th>
                            <th>Keluhan</th>
                            <th>Resep Obat</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach ($kunjungan as $item)
                            <tr>
                                <td>{{ date('d F Y', strtotime($item->kunjungan->tanggal_kunjungan)) }}</td>
                                <td>
                                    @if(!is_null($item->poli_id))
                                        Rawat Jalan
                                    @elseif(!is_null($item->apotek_id))
                                        Apotek
                                    @elseif(!is_null($item->lab_id))
                                        Laboratorium
                                    @else
                                        -
                                    @endif
                                </td>
                                <td>{{ $item->kunjungan->keluhan }}</td>
                                <td>{{ $item->diagnosa }}</td>
                                <td>{{ $item->resep }}</td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

        </section>
    </div>
@endsection
@push('scripts')
    <script src={{ asset ('assets/extensions/simple-datatables/umd/simple-datatables.js') }}></script>
    <script>
        let dataTable = new simpleDatatables.DataTable(
            document.getElementById("table1")
        )
    </script>
@endpush

resources/views/rekam-medis/entry-kunjungan/index.blade.php
@extends('templates.master')
@section('title', 'Rekam Medis')
@section('page-name', 'Entry Kunjungan')
@push('styles')
    <link rel="stylesheet" href={{ asset('assets/extensions/simple-datatables/style.css') }}>
    <link rel="stylesheet" href={{ asset('assets/scss/pages/simple-datatables.scss') }}>
@endpush
@section('content')
    <div class="page-heading">
        <section class="section">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title">
                        Data Kunjungan Pasien
                    </h5>
                    <a class="btn btn-primary" href="{{ route('entry-kunjungan.create') }}">
                        <i class="bi bi-plus"></i>Data
                    </a>
                    <span class="float-end" id="waktu-kunjungan"></span>
                </div>
                <div class="card-body">
                    <table class="table table-striped" id="table1">
                        <thead>
                        <tr>
                            <th>No Kunjungan</th>
                            <th>Nama Pasien</th>
                            <th>No. BPJS</th>
                            <th>Tanggal Kunjungan</th>
                            <th>Detail</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach ($kunjungan as $item)
                            <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $item->pasien->nama }}</td>
                                <td>{{ $item->pasien->no_bpjs }}</td>
                                <td>{{ date('d F Y', strtotime($item->tanggal_kunjungan)) }}</td>
                                <td>
                                    <a href="{{ route('entry-kunjungan.detail', $item->id) }}" class="btn btn-primary">
                                        <i class="bi bi-eye"></i>
                                    </a>
                                </td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                </div>
            </div>

        </section>
    </div>
@endsection
@push('scripts')
    <script src={{ asset ('assets/extensions/simple-datatables/umd/simple-datatables.js') }}></script>
    <script src={{ asset ('https://code.jquery.com/jquery-3.6.0.min.js') }}></script>
    <script>
        let dataTable = new simpleDatatables.DataTable(
            document.getElementById("table1")
        )
        $(document).ready(function () {
            function updateWaktuKunjungan() {
                var options = {
                    weekday: 'long',
                    year: 'numeric',
                    month: 'long',
                    day: 'numeric'
                };
                var waktuSaatIni = new Date().toLocaleDateString('id-ID', options);
                $("#waktu-kunjungan").text("Hari : " + waktuSaatIni);
            }

            setInterval(updateWaktuKunjungan, 1000);
        });
    </script>
@endpush